import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;

import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMResult;
import javax.xml.transform.sax.SAXSource;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathFactory;

import org.ccil.cowan.tagsoup.Parser;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;

import twitter4j.Query;
import twitter4j.QueryResult;
import twitter4j.Status;
import twitter4j.Twitter;
import twitter4j.TwitterException;
import twitter4j.TwitterFactory;
import twitter4j.URLEntity;
import twitter4j.conf.ConfigurationBuilder;

public class Ethnologue {
	// Initialize library objects
	private Twitter twitter;
    private XMLReader reader = new Parser();
	private XPath xpath = XPathFactory.newInstance().newXPath();
	
	// Construct library objects
	Ethnologue()
	{
	    try {
			reader.setFeature(Parser.namespacesFeature, false);
		} catch (Exception e) {
			// Should not happen
			e.printStackTrace();
			System.exit(1);
		} 
	    
		ConfigurationBuilder cb = new ConfigurationBuilder();
		// TODO: Enter your twitter keys and secrets, as given in the list of your applications
		// on the Twitter Dev Web site
		cb.setDebugEnabled(true)
		  .setOAuthConsumerKey("TODO")
		  .setOAuthConsumerSecret("TODO")
		  .setOAuthAccessToken("TODO")
		  .setOAuthAccessTokenSecret("TODO");
		TwitterFactory tf = new TwitterFactory(cb.build());
		twitter = tf.getInstance();
	}
	
	// Transform a Twitter status into a TwitterEthnologueReference object
	private TwitterEthnologueReference statusToTwitterEthnologueReference(Status s)
	{
		// TODO: write this function
		return null;
	}
	
	// Utility function returning a DOM node of the HTML document referenced at the URL given in input
	private Node urlToHTMLNode(URL u) throws Exception
	{
	    InputStream input = u.openStream();

	    Transformer transformer = TransformerFactory.newInstance().newTransformer();

	    DOMResult result = new DOMResult();
	    transformer.transform(new SAXSource(reader, new InputSource(input)), result);
	    return result.getNode();
	}
	
	// Return an object describing the reference to Ethnologue in the Tweet with the id given in input
	public TwitterEthnologueReference get(long id) throws TwitterException
	{
		// TODO: write this function
		
		return null;
	}
	
	// Return a list of c tweets containing references to Ethnologue, using Twitter Search 
	public List<Long> search(int c) throws TwitterException {
		// TODO: write this function
		
	    return null;
	}
}
