import java.net.URL;

public class TwitterEthnologueReference {
	public String languageCode; // three-letter language code
	
	public String tweetUserName; // user name of Twitter user
	public String tweetContent; // textual content of the tweet
	public long tweetId; // id of the tweet
	
	public URL ethnologueURL; // URL of the page with information on the language on the Ethnologue Web site 
	public String ethnologueLanguageName; // Main language name, as given by Ethnologue
	public int ethnologuePopulation; // Population, as given by Ethnologue (take the 1st number appearing as population in the field)
}